commit c9d2a4cffd795254df6ac183e771d4f93b3a857a
Merge: fd686abeea1 109403eb394
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Tue Feb 6 21:28:28 2024 +0530

    Merge pull request #5220 from VarunNagaraju/PS-9096
    
    PS-9096 Backport bug fixes from MySQL 8.0

commit 4400b0a9c86d6c1ce6f8f3b2ba432f1067357347
Author: Yura Sorokin <yura.sorokin@percona.com>
Date:   Thu Feb 8 02:53:04 2024 +0100

    PS-9048 fix: Fixed problem with percent character in n-grams
    
    https://perconadev.atlassian.net/browse/PS-9048
    
    Fixed problem with 'fts_index_fetch_nodes()' function not being able to
    properly handle situations when 'word' parameter contained special characters
    used by 'LIKE' clauses ('%' and '_'). Introduced additional boolean parameter
    'exact_match' that instructs this function to use either 'WHERE word = :word'
    or 'WHERE word LIKE :word' clauses when selecting records from internal FTS
    tables. We call 'fts_index_fetch_nodes()' with 'exact_match' set to 'true'
    only from 'fts_optimize_words()' (when we perform 'OPTIMIZE TABLE' under
    'innodb_optimize_fulltext_only' enabled). In every other place
    * fts_query_difference()
    * fts_query_intersect()
    * fts_query_union()
    * fts_query_phrase_search()
    where we indeed need pattern matching we call this function with 'exact_match'
    set to 'false' (instructing the function to use the 'LIKE' clause).
    
    Added six new MTR test cases:
    * 'innodb_fts.percona_ft_special_chars_default_ewc_on'
    * 'innodb_fts.percona_ft_special_chars_default_ewc_off'
    * 'innodb_fts.percona_ft_special_chars_ngram_ewc_on'
    * 'innodb_fts.percona_ft_special_chars_ngram_ewc_off'
    * 'innodb_fts.percona_ft_special_chars_mecab_ewc_on'
    * 'innodb_fts.percona_ft_special_chars_mecab_ewc_off'
    which reproduce original crash scenario using default / ngram / mecab parsers,
    under both 'ft_query_extra_word_chars' set to 'ON' and 'OFF'. These tests cases
    also check parsing / querying strings containing various special characters.
    Please note that they have "result mismatch" status strings recorded in the
    '.result' files for certain combinations of special characters and this is
    expected behavior.
    
    Introduced two new MTR helper '.inc' files:
    * percona_install_mecab_plugin.inc
    * percona_uninstall_mecab_plugin.inc
    which help install / uninstall the mecab plugin along with creating / removing
    its settings file.
    'innodb_fts.percona_mecab_null_character' MTR test case reworked with these two
    include files.

diff --git a/mysql-test/suite/innodb_fts/include/percona_ft_special_chars.inc b/mysql-test/suite/innodb_fts/include/percona_ft_special_chars.inc
new file mode 100644
index 00000000000..6a93d43aafa
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/include/percona_ft_special_chars.inc
@@ -0,0 +1,331 @@
+--let $fts_parser_clause =
+if ($fts_parser != '')
+{
+  --let $fts_parser_clause = WITH PARSER $fts_parser
+}
+
+--echo *** saving global system variables
+SET @old_innodb_optimize_fulltext_only = @@global.innodb_optimize_fulltext_only;
+SET GLOBAL innodb_optimize_fulltext_only = ON;
+
+SET @old_innodb_ft_aux_table = @@global.innodb_ft_aux_table;
+
+--echo
+--echo *** creating a simple table with a full text index
+SET innodb_ft_enable_stopword = OFF;
+eval CREATE TABLE t1 (c TINYTEXT, FULLTEXT KEY (c) $fts_parser_clause) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
+SET GLOBAL innodb_ft_aux_table = 'test/t1';
+
+--echo
+--echo ***************************************
+--echo *** Part I: original crash scenario ***
+--echo ***************************************
+
+--echo
+--echo *** inserting a record containing the '%' character
+SET @special_string = 'vdf%vdfd%ghdi%opu';
+--let $special_string = `SELECT @special_string`
+# for both default and mecab parser
+if ($fts_parser != ngram)
+{
+  # there are 4 words separated by the '%' character
+  --let $expected_number_of_records = 4
+}
+if ($fts_parser == ngram)
+{
+  --let $expected_number_of_records = `SELECT LENGTH(@special_string) - 1`
+}
+INSERT INTO t1 VALUES (@special_string);
+
+--let $assert_text = number of records in the index cache after inserting '$special_string' is expected to be $expected_number_of_records
+--let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE] = $expected_number_of_records
+--source include/assert.inc
+SELECT WORD FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE ORDER BY WORD;
+
+--let $assert_text = number of records in the index table after inserting '$special_string' is expected to be zero
+--let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE] = 0
+--source include/assert.inc
+
+OPTIMIZE TABLE t1;
+
+--echo
+--echo *** updating the table with another record also containing the '%' character
+SET @special_string = 'sd%he%ff';
+--let $special_string = `SELECT @special_string`
+--let $old_expected_number_of_records = $expected_number_of_records
+# for both default and mecab parser
+if ($fts_parser != ngram)
+{
+  --let $expected_number_of_records = 3
+}
+if ($fts_parser == ngram)
+{
+  --let $expected_number_of_records = `SELECT LENGTH(@special_string) - 1`
+}
+UPDATE t1 SET c = @special_string;
+
+--let $assert_text = number of records in the index cache after updating to '$special_string' is expected to be $expected_number_of_records
+--let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE] = $expected_number_of_records
+--source include/assert.inc
+SELECT WORD FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE ORDER BY WORD;
+
+--let $assert_text = number of records in the index table after updating to '$special_string' is expected to be $old_expected_number_of_records
+--let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE] = $old_expected_number_of_records
+--source include/assert.inc
+SELECT WORD FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE ORDER BY WORD;
+
+OPTIMIZE TABLE t1;
+
+--let $assert_text = number of records in the index cache after updating to '$special_string' and optimizing is expected to be zero
+--let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE] = 0
+--source include/assert.inc
+
+--let $assert_text = number of records in the index table after updating to '$special_string' and optimizing is expected to be $expected_number_of_records
+--let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE] = $expected_number_of_records
+--source include/assert.inc
+SELECT WORD FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_TABLE ORDER BY WORD;
+
+--echo
+--echo *** deleting the record
+DELETE FROM t1;
+OPTIMIZE TABLE t1;
+
+--echo
+--echo **************************************************
+--echo *** Part II: indexing other special characters ***
+--echo **************************************************
+
+--echo
+--echo *** creating a list of all printable characters (ASCII 33..126)
+--echo *** (whitespace and control characters are excluded)
+
+delimiter |;
+CREATE FUNCTION generate_special_characters(range_from TINYINT UNSIGNED, range_to TINYINT UNSIGNED) RETURNS VARCHAR(256) DETERMINISTIC
+BEGIN
+  DECLARE i TINYINT UNSIGNED DEFAULT range_from;
+  DECLARE res VARCHAR(256) DEFAULT '';
+  WHILE i <= range_to DO
+    SET res = CONCAT(res, CHAR(i USING ascii));
+    SET i = i + 1;
+  END WHILE;
+  RETURN res;
+END|
+delimiter ;|
+
+SET @special_characters = generate_special_characters(33, 126);
+SELECT @special_characters;
+
+DROP FUNCTION generate_special_characters;
+
+--echo
+--echo *** for each character from the set we create a string containing this character
+--echo *** and perform SELECTs with various MATCH() ... AGAINST() clauses (both in
+--echo *** NATURAL LANGUAGE and BOOLEAN modes)
+
+--echo
+--echo *** please note that it is totally OK that some of these checks do not return
+--echo *** the result we call "expected" - a number of characters have special meaning
+--echo *** (especially in BOOLEAN mode) - our goal here is to test for crashes
+
+--echo
+--echo *** also we expect the number of mismatches to be much lower when
+--echo *** 'ft_query_extra_word_chars' is set to 'ON'
+--echo
+
+--disable_query_log
+--disable_result_log
+
+--let $number_of_characters = `SELECT LENGTH(@special_characters)`
+--let $charaacted_idx = 0
+while ($charaacted_idx < $number_of_characters)
+{
+  eval SET @special_char = SUBSTRING(@special_characters, $charaacted_idx + 1, 1);
+  --let $special_char = `SELECT @special_char`
+  SET @special_string = CONCAT('abc', @special_char, 'def');
+  # for both default and mecab parser
+  if ($fts_parser == '')
+  {
+    SET @alnum_plus_character = @special_char REGEXP '^[a-zA-Z0-9_]';
+    --let $expected_number_of_records = `SELECT IF(@alnum_plus_character, 1, 2)`
+  }
+  if ($fts_parser == ngram)
+  {
+    --let $expected_number_of_records = `SELECT LENGTH(@special_string) - 1`
+  }
+  if ($fts_parser == mecab)
+  {
+    SET @alnum_plus_character = @special_char REGEXP '^[a-zA-Z]';
+    --let $expected_number_of_records = `SELECT IF(@alnum_plus_character, 1, 2)`
+  }
+  INSERT INTO t1 VALUES(@special_string);
+
+  --let $assert_text = number of records for the special string containing '$special_char' is expected to be $expected_number_of_records
+  --let $assert_cond = [SELECT COUNT(*) FROM INFORMATION_SCHEMA.INNODB_FT_INDEX_CACHE] = $expected_number_of_records
+  --source include/assert.inc
+
+  if ($fts_parser != ngram)
+  {
+    SET @expected_matches = JSON_ARRAY(
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'abc', 'result', IF(@alnum_plus_character, 0, 1)),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'def', 'result', IF(@alnum_plus_character, 0, 1)),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('abc', @special_char, 'def'), 'result', IF(@alnum_plus_character, 1, 0)),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'a', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'b', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'c', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', @special_char, 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'd', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'e', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'f', 'result', 0),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'ab', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'bc', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('c', @special_char), 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT(@special_char, 'd'), 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'de', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'ef', 'result', 0),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'zbc', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'dez', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('bc', @special_char, 'de'), 'result', 0),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('abc', @special_char), 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT(@special_char, 'def'), 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('zabc', @special_char, 'def'), 'result', 0),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'abc', 'result', IF(@alnum_plus_character, 0, 1)),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'def', 'result', IF(@alnum_plus_character, 0, 1)),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('abc', @special_char, 'def'), 'result', IF(@alnum_plus_character, 1, 0)),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'a', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'b', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'c', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', @special_char, 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'd', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'e', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'f', 'result', 0),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'ab', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'bc', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('c', @special_char), 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT(@special_char, 'd'), 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'de', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'ef', 'result', 0),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'zbc', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'dez', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('bc', @special_char, 'de'), 'result', 0),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('abc', @special_char), 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT(@special_char, 'def'), 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('zabc', @special_char, 'def'), 'result', 0)
+    );
+  }
+
+  if ($fts_parser == ngram)
+  {
+    SET @expected_matches = JSON_ARRAY(
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'a', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'b', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'c', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', @special_char, 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'd', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'e', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'f', 'result', 0),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'ab', 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'bc', 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('c', @special_char), 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT(@special_char, 'd'), 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'de', 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'ef', 'result', 1),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'ac', 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('z', @special_char), 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT(@special_char, 'z'), 'result', 0),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'df', 'result', 0),
+
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'abc', 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('bc', @special_char), 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT('c', @special_char, 'd'), 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', CONCAT(@special_char, 'de'), 'result', 1),
+      JSON_OBJECT('mode', 'NATURAL LANGUAGE', 'pattern', 'def', 'result', 1),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'a', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'b', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'c', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', @special_char, 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'd', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'e', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'f', 'result', 0),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'ab', 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'bc', 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('c', @special_char), 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT(@special_char, 'd'), 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'de', 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'ef', 'result', 1),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'ac', 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('z', @special_char), 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT(@special_char, 'z'), 'result', 0),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'df', 'result', 0),
+
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'abc', 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('bc', @special_char), 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT('c', @special_char, 'd'), 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', CONCAT(@special_char, 'de'), 'result', 1),
+      JSON_OBJECT('mode', 'BOOLEAN', 'pattern', 'def', 'result', 1)
+    );
+  }
+
+  --let $number_of_queries = `SELECT JSON_LENGTH(@expected_matches)`
+  --let $query_idx = 0
+  while ($query_idx < $number_of_queries)
+  {
+    eval SET @extraction_common_path = CONCAT(CHAR(36 USING utf8mb4), '[$query_idx]');
+    eval SET @extraction_mode_path = CONCAT(@extraction_common_path, '.mode');
+    eval SET @extraction_pattern_path = CONCAT(@extraction_common_path, '.pattern');
+    eval SET @extraction_result_path = CONCAT(@extraction_common_path, '.result');
+
+    --let $mode = `SELECT JSON_UNQUOTE(JSON_EXTRACT(@expected_matches, @extraction_mode_path))`
+    SET @pattern = JSON_UNQUOTE(JSON_EXTRACT(@expected_matches, @extraction_pattern_path));
+    --let $pattern = `SELECT @pattern`
+    --let $expected_result = `SELECT JSON_EXTRACT(@expected_matches, @extraction_result_path)`
+
+    --error 0, ER_PARSE_ERROR
+    eval SELECT COUNT(*) INTO @query_result FROM t1 WHERE MATCH(c) AGAINST (@pattern IN $mode MODE);
+    if ($mysql_errno)
+    {
+      --echo *** mode: "$mode", pattern: "$pattern", expected result: $expected_result, FTS syntax error
+    }
+    if (!$mysql_errno)
+    {
+      --let $result = `SELECT @query_result`
+      if ($result != $expected_result)
+      {
+        --echo *** mode: "$mode", pattern: "$pattern", expected result: $expected_result, result: $result
+      }
+    }
+
+
+    --inc $query_idx
+  }
+
+  DELETE FROM t1;
+  OPTIMIZE TABLE t1;
+
+  --inc $charaacted_idx
+}
+
+--enable_result_log
+--enable_query_log
+
+--echo
+--echo *** dropping the table
+DROP TABLE t1;
+
+--echo
+--echo *** restoring global system variables
+SET GLOBAL innodb_ft_aux_table = @old_innodb_ft_aux_table;
+SET GLOBAL innodb_optimize_fulltext_only = @old_innodb_optimize_fulltext_only;
diff --git a/mysql-test/suite/innodb_fts/include/percona_install_mecab_plugin.inc b/mysql-test/suite/innodb_fts/include/percona_install_mecab_plugin.inc
new file mode 100644
index 00000000000..a2ba581b490
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/include/percona_install_mecab_plugin.inc
@@ -0,0 +1,50 @@
+eval INSTALL PLUGIN mecab SONAME '$MECAB';
+
+--let $ipadic_charset = utf-8
+--let $mysql_charset = utf8
+--let $mecab_charset = `SELECT variable_value FROM performance_schema.global_status WHERE VARIABLE_NAME = 'mecab_charset'`
+
+if ($mecab_charset == '')
+{
+  # restart with package dictionary
+  --let $MYSQL_DATADIR = `SELECT @@datadir`
+  --let $MYSQL_BASEDIR = `SELECT @@basedir`
+
+  --let $mecabrc = $MYSQL_DATADIR/mecabrc
+  --let $dicdir = $MYSQL_BASEDIR/lib/mecab/dic/ipadic_$ipadic_charset
+
+  --exec echo "dicdir=$dicdir" > $mecabrc
+
+  --let $restart_parameters = "restart: --loose-mecab-rc-file=$mecabrc $MECAB_OPT --innodb-ft-min-token_size=2"
+  --let $do_not_echo_parameters = 1
+  --source include/restart_mysqld.inc
+
+  eval INSTALL PLUGIN mecab SONAME '$MECAB';
+
+  --let $mecab_charset = `SELECT variable_value FROM performance_schema.global_status WHERE VARIABLE_NAME = 'mecab_charset'`
+}
+
+if ($mecab_charset != $mysql_charset)
+{
+  --let $skip_message_idx = 0
+  if ($mecab_charset != '')
+  {
+    UNINSTALL PLUGIN mecab;
+    --let $skip_message_idx = 1
+  }
+  if ($mecabrc != '')
+  {
+    --remove_file $mecabrc
+    --let $mecabrc =
+  }
+  if ($skip_message_idx == 0)
+  {
+    --skip Test fail to load mecab parser, please set correct 'loose_mecab_rc_file'.
+  }
+  if ($skip_message_idx == 1)
+  {
+    --skip Test mecab charset mismatch
+  }
+}
+
+SHOW STATUS LIKE 'mecab_charset';
diff --git a/mysql-test/suite/innodb_fts/include/percona_uninstall_mecab_plugin.inc b/mysql-test/suite/innodb_fts/include/percona_uninstall_mecab_plugin.inc
new file mode 100644
index 00000000000..ca8c9ecf39f
--- /dev/null
+++ b/mysql-test/suite/innodb_fts/include/percona_uninstall_mecab_plugin.inc
@@ -0,0 +1,6 @@
+UNINSTALL PLUGIN mecab;
+if ($mecabrc != '')
+{
+  --remove_file $mecabrc
+  --let $mecabrc =
+}
